unit Unit1;

{
  find trigonometric identities for integer angles
  DavData software, mai 2022
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, math, ExtCtrls, shellApi;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    GObtn: TBitBtn;
    msglabel: TStaticText;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Image1: TImage;
    Label11: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure GObtnClick(Sender: TObject);
    procedure Label2MouseEnter(Sender: TObject);
    procedure Label2MouseLeave(Sender: TObject);
    procedure Label2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const degtoRad : double = pi/180;
      radtoDeg : double = 180/pi;
      max2 = 4004;   //89-1+2)!/(89-1)! - 1
      max3 = 121484; //(89-1+3)!/(89-1)! - 1
      maxfraction = 28;

type TProduct2 = record
                  A1,A2 : byte;
                  v : longInt;
                 end;
     TProduct3 = record
                  A1,A2,A3 : byte; //angles
                  v : longInt;     //sine product *1e9
                 end;
     Tsum2     = record
                  A1,A2 : byte;
                  v : double;
                 end;
     Tfraction = record
                  num,den : byte;
                  xasin : double;
                  xatan : double;
                 end;

var sinetable : array[1..90] of double; //for angles 1..89
    sine2sumtable : array[0..max2] of TProduct2;
    sine2prodtable : array[0..max2] of TProduct2;
    sine3prodtable : array[0..max3] of TProduct3; //sin(A)sin(B)sin(c)
    tantable : array[1..89] of double;
    tan2sumtable : array[0..max2] of Tsum2;
    tan2prodtable : array[0..max2] of Tsum2;
    fractiontable : array[1..maxfraction] of Tfraction;
    idselected : Tlabel;
    idcount : word;

procedure makesinetable;
var i : byte;
begin
 for i := 1 to 90 do sinetable[i] := sin(i*DegtoRad);
end;

procedure makesine2sumtable;
var i,j : byte;
    n : word;
begin
 n := 0;
 for i := 1 to 89 do
  for j := i to 89 do
   with sine2sumtable[n] do
    begin
     A1 := i; A2 := j;
     v := round((sinetable[i]+sinetable[j])*1e9);
     inc(n);
    end;
end;

procedure makesine2producttable;
var i,j : byte;
    n : word;
begin
 n := 0;
 for i := 1 to 89 do
  for j := i to 89 do
   with sine2prodtable[n] do
    begin
     A1 := i; A2 := j;
     v := round(sinetable[i]*sinetable[j]*1e9);
     inc(n);
    end;
end;

procedure makesine3productTable;
var i,j,k : byte;
    n : longInt;
    P : double;
begin
 n := 0;
 for i := 1 to 89 do
  for j := i to 89 do
   begin
    P := sinetable[i]*sinetable[j];
    for k := j to 89 do
     with sine3prodtable[n] do
      begin
       A1 := i; A2 := j; A3 := k;
       v := round(P*sinetable[k]*1e9);
       inc(n);
      end;
   end;
end;

procedure maketantable;
var i : byte;
begin
 for i := 1 to 89 do tantable[i] := tan(i*degtorad);
end;

procedure maketan2sumtable;
var i,j : byte;
    n : word;
begin
 n := 0;
 for i := 1 to 89 do
  for j := i to 89 do
   with tan2sumtable[n] do
    begin
     A1 := i; A2 := j;
     v := tantable[i]+tantable[j];
     inc(n);
    end;
end;

procedure maketan2producttable;
var i,j : byte;
    n : word;
begin
 n := 0;
 for i := 1 to 89 do
  for j := i to 89 do
   with tan2prodtable[n] do
    begin
     A1 := i; A2 := j;
     v := tantable[i]*tantable[j];
     inc(n);
    end;
end;

function GCD(a,b : word) : word;
//calculate greatest common divisor of a,b  (byte)
var h : word;
begin
 while a > 0 do
  begin
   if a < b then begin
                  h := a;
                  a := b;
                  b := h;
                 end;
   a := a mod b;
  end;
 result := b;
end;

procedure makefractionTable;
const mults = 2520;
var i,m,n,bn,bd : word;
    d : double;
begin
 n := 0;
 for i := 1 to mults do      // fraction i/30
  begin
   m := GCD(mults,i);
   bn := i div m;
   bd := mults div m;
   if bd < 10 then
    begin
     d := bn/bd;
     inc(n);
     with fractionTable[n] do
      begin
       num := bn;
       den := bd;
       xasin := arcsin(d);
       xatan := arctan(d);
      end;
    end;  
  end;
end;

function Intstring(L : byte; v : word) : string;
//make string of v with length L
begin
 result := inttostr(v);
 while length(result) < L do insert(' ',result,1);
end;

//-- identity processors

procedure identity1;
//sine sum 2*1
const st ='sin(';
      sp = ')';
var i,j : longInt;
    A1,A2 : byte;
    s : string;
begin
 for i := 0 to max2-1 do
  begin
   A1 := sine2sumtable[i].A1;
   A2 := sine2sumtable[i].A2;
   for j := 1 to 90 do 
    if sine2sumtable[i].v = round(sinetable[j]*1e9) then
     begin
      inc(idcount);
      s := Intstring(4,idcount)+' ';
      s := s + st + intstring(2,A1) + sp;
      s := s + ' + ' + st + intstring(2,A2) + sp + ' = ';
      s := s + st + intstring(2,j) + sp;
      form1.memo1.lines.add(s);
     end;
  end;
end;

procedure identity2;
//sine sum 2*2
const st ='sin(';
      sp = ')';
var i,j : longInt;
    A1,A2 : byte;
    B1,B2 : byte;
    s : string;
begin
 for i := 0 to max2-1 do
  begin
   A1 := sine2sumtable[i].A1;
   A2 := sine2sumtable[i].A2;
   for j := i+1 to max2 do
    if sine2sumtable[i].v = sine2sumtable[j].v then
     begin
      B1 := sine2sumtable[j].A1;
      B2 := sine2sumtable[j].A2;
      if (A1 <> B1) and (A1 <> B2) and
         (A2 <> B1) and (A2 <> B2) then
       begin
        inc(idcount);
        s := Intstring(4,idcount)+' ';
        s := s + st + intstring(2,A1) + sp;
        s := s + ' + ' + st + intstring(2,A2) + sp + ' = ';
        s := s + st + intstring(2,B1) + sp;
        s := s + ' + ' + st + intstring(2,B2) + sp;
        form1.memo1.lines.add(s);
       end;
     end;
  end;
end;

procedure identity3;
//sine product 2*1 variables
const st ='sin(';
      sp = ')';
var i,j : longInt;
    A1,A2 : byte;
    s : string;
begin
 for i := 0 to max2-1 do
  begin
   A1 := sine2prodtable[i].A1;
   A2 := sine2prodtable[i].A2;
   for j := 1 to 89 do
    if sine2prodtable[i].v = round(sinetable[j]*1e9) then
     begin
      inc(idcount);
      s := Intstring(4,idcount)+' ';
      s := s + st + intstring(2,A1) + sp;
      s := s + st + intstring(2,A2) + sp + ' = ';
      s := s + st + intstring(2,j) + sp;
      form1.memo1.lines.add(s);
     end;
  end;
end;

procedure identity4;
//sine product 2*2 variables
const st ='sin(';
      sp = ')';
var i,j : longInt;
    A1,A2 : byte;
    B1,B2 : byte;
    s : string;
begin
 for i := 0 to max2-1 do
  begin
   A1 := sine2prodtable[i].A1;
   A2 := sine2prodtable[i].A2;
   for j := i+1 to max2 do
    if sine2prodtable[i].v = sine2prodtable[j].v then
     begin
      B1 := sine2prodtable[j].A1;
      B2 := sine2prodtable[j].A2;
      if (A1 <> B1) and (A1 <> B2) and
         (A2 <> B1) and (A2 <> B2) then
       begin
        inc(idcount);
        s := Intstring(4,idcount)+' ';
        s := s + st + intstring(2,A1) + sp;
        s := s + st + intstring(2,A2) + sp + ' = ';
        s := s + st + intstring(2,B1) + sp;
        s := s + st + intstring(2,B2) + sp;
        form1.memo1.lines.add(s);
       end;
     end;
  end;
end;

procedure identity5;
//sine product 2*3 variables
const st ='sin(';
      sp = ')';
var i,j : longInt;
    A1,A2,A3 : byte;
    B1,B2,B3 : byte;
    s : string;
begin
 for i := 0 to max3-1 do
  begin
   A1 := sine3prodtable[i].A1;
   A2 := sine3prodtable[i].A2;
   A3 := sine3prodtable[i].A3;
   for j := i+1 to max3 do
    if sine3prodtable[i].v = sine3prodtable[j].v then
     begin
      B1 := sine3prodtable[j].A1;
      B2 := sine3prodtable[j].A2;
      B3 := sine3prodtable[j].A3;
      if (A1 <> B1) and (A1 <> B2) and (A1 <> B3) and
         (A2 <> B1) and (A2 <> B2) and (A2 <> B3) and
         (A3 <> B1) and (A3 <> B2) and (A3 <> B3) then
       begin
        inc(idcount);
        s := Intstring(4,idcount)+' ';
        s := s + st + intstring(2,A1) + sp;
        s := s + st + intstring(2,A2) + sp;
        s := s + st + intstring(2,A3) + sp + ' = ';
        s := s + st + intstring(2,B1) + sp;
        s := s + st + intstring(2,B2) + sp;
        s := s + st + intstring(2,B3) + sp;
        form1.memo1.lines.add(s);
       end;
     end;
  end;
end;

procedure identity6;
//tan sum 2*1 variables
const st ='tan(';
      sp = ')';
var i,j : longInt;
    A1,A2 : byte;
    s : string;
begin
 for i := 0 to max2-1 do
  begin
   A1 := tan2sumtable[i].A1;
   A2 := tan2sumtable[i].A2;
   for j := 1 to 89 do
    if abs(tan2sumtable[i].v - tantable[j]) < 1e-6 then
     begin
      inc(idcount);
      s := Intstring(4,idcount)+' ';
      s := s + st + intstring(2,A1) + sp;
      s := s + st + intstring(2,A2) + sp + ' = ';
      s := s + st + intstring(2,j) + sp;
      form1.memo1.lines.add(s);
     end;
  end;
end;

procedure identity7;
//tan sum 2*2 variables
const st ='tan(';
      sp = ')';
var i,j : longInt;
    A1,A2 : byte;
    B1,B2 : byte;
    s : string;
begin
 for i := 0 to max2-1 do
  begin
   A1 := tan2sumtable[i].A1;
   A2 := tan2sumtable[i].A2;
   for j := i+1 to max2 do
    if abs(tan2sumtable[i].v - tan2sumtable[j].v) < 1e-9 then
     begin
      B1 := tan2sumtable[j].A1;
      B2 := tan2sumtable[j].A2;
      if (A1 <> B1) and (A1 <> B2) and
         (A2 <> B1) and (A2 <> B2) then
       begin
        inc(idcount);
        s := Intstring(4,idcount)+' ';
        s := s + st + intstring(2,A1) + sp;
        s := s + ' + ' + st + intstring(2,A2) + sp + ' = ';
        s := s + st + intstring(2,B1) + sp;
        s := s + ' + '+ st + intstring(2,B2) + sp;
        form1.memo1.lines.add(s);
       end;
     end;
  end;
end;

procedure identity8;
//tangent product 2*2
const st ='tan(';
      sp = ')';
var i,j : longInt;
    A1,A2 : byte;
    B1,B2 : byte;
    s : string;
begin
 for i := 0 to max2-1 do
  begin
   A1 := tan2prodtable[i].A1;
   A2 := tan2prodtable[i].A2;
   for j := i+1 to max2 do
    if abs(tan2prodtable[i].v - tan2prodtable[j].v) < 1e-9 then
     begin
      B1 := tan2prodtable[j].A1;
      B2 := tan2sumtable[j].A2;
      if (A1 <> B1) and (A1 <> B2) and
         (A2 <> B1) and (A2 <> B2) then
       begin
        inc(idcount);
        s := Intstring(4,idcount)+' ';
        s := s + st + intstring(2,A1) + sp;
        s := s + st + intstring(2,A2) + sp + ' = ';
        s := s + st + intstring(2,B1) + sp;
        s := s + st + intstring(2,B2) + sp;
        form1.memo1.lines.add(s);
       end;
     end;
  end;
end;

procedure identity9;
const s1 = 'arctan(';
      sp = ')';
      sf = '/';
var i,j,k : byte;
    v : double;
    s : string;
begin
 for i := 1 to maxfraction do
  for j := i to maxfraction do
   begin
    v := (fractiontable[i].xatan + fractiontable[j].xatan)*radtoDeg;
    k := round(v);
    if abs(v-k) < 1e-9 then
     begin
      inc(idcount);
      s := intstring(4,idcount)+'  ';
      s := s + s1 + intstring(2,fractiontable[i].num)+ sf;
      s := s + intstring(2,fractiontable[i].den) + sp + ' + ';
      s := s + s1 + intstring(2,fractiontable[j].num)+ sf;
      s := s + intstring(2,fractiontable[j].den) + sp + ' = ';
      s := s + intstring(2,k);
      form1.memo1.Lines.add(s);
     end;
   end;
end;

procedure identity10;
const s1 = 'arcsin(';
      sp = ')';
      sf = '/';
var i,j,k : byte;
    v : double;
    s : string;
begin
 for i := 1 to maxfraction do
  for j := i to maxfraction do
   begin
    v := (fractiontable[i].xasin + fractiontable[j].xasin)*radtoDeg;
    k := round(v);
    if abs(v-k) < 1e-9 then
     begin
      inc(idcount);
      s := intstring(4,idcount)+'  ';
      s := s + s1 + intstring(2,fractiontable[i].num)+ sf;
      s := s + intstring(2,fractiontable[i].den) + sp + ' + ';
      s := s + s1 + intstring(2,fractiontable[j].num)+ sf;
      s := s + intstring(2,fractiontable[j].den) + sp + ' = ';
      s := s + intstring(2,k);
      form1.memo1.Lines.add(s);
     end;
   end;
end;

//-- events --

procedure TForm1.GObtnClick(Sender: TObject);
//search for identities
var s : string;
begin
 if idselected = nil then begin
                           msglabel.Caption := 'no identity selected';
                           exit;
                          end;
 memo1.Clear;
 idcount := 0;
 msglabel.Caption := 'searching...';
 case idselected.tag of
  1 : identity1;
  2 : identity2;
  3 : identity3;
  4 : identity4;
  5 : identity5;
  6 : identity6;
  7 : identity7;
  8 : identity8;
  9 : identity9;
 10 : identity10; 
 end;//case
 s := 'finished. ';
 s := s + inttostr(idcount)+' equalities found';
 msglabel.caption := s;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 makesinetable;
 makesine2sumtable;
 makesine2producttable;
 makesine3producttable;
 maketantable;
 maketan2sumtable;
 maketan2producttable;
 makefractiontable;
 msglabel.caption := 'tables generated. Select identity, press GO';
end;

procedure paintidedge(lab : Tlabel; color : dword);
//ct: control tag nr
var x1,x2,y1,y2 : word;
    i : byte;
begin
 x1 := lab.Left-1;
 x2 := lab.Left+lab.Width+1;
 y1 := lab.Top-1;
 y2 := lab.Top+lab.height+1;
 with form1.Canvas do
  begin
   pen.Width := 1;
   pen.Color := color;
   for i := 0 to 1 do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(x1+i,y1+i);
    end;
  end;
end;

procedure TForm1.Label2MouseEnter(Sender: TObject);
var lab : TLabel;
begin
 lab := TLabel(sender);
 paintidedge(lab,$0000ff);
end;

procedure TForm1.Label2MouseLeave(Sender: TObject);
var lab : Tlabel;
begin
 lab := Tlabel(sender);
 if idselected=lab then paintidedge(lab,$000000)
  else paintidedge(lab,$c0c0c0);
end;

procedure TForm1.Label2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var lab : TLabel;
begin
 if assigned(idselected) then paintidedge(idselected,$c0c0c0);
 lab := Tlabel(sender);
 idselected := lab;
 paintidedge(lab,$000000);
end;

procedure TForm1.FormPaint(Sender: TObject);
var i : byte;
    obj : TObject;
    lab : Tlabel;
    color : dword;
begin
 for i := 0 to componentcount-1 do
 begin
  obj := form1.components[i];
  if obj is TLabel then
   begin
    lab := Tlabel(obj);
    if lab.Tag > 0 then
     begin
      if lab = idselected then color := $000000 else color := $c0c0c0;
      paintidedge(lab,color);
     end;
   end;
 end;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
 ShellExecute(0,'open','http://www.davdata.nl/math', nil, nil, SW_SHOWNORMAL);
end;

end.
